'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _simpleHl = require('simple-hl7');

var _simpleHl2 = _interopRequireDefault(_simpleHl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Encoder = function () {
  function Encoder(message_to_encode) {
    _classCallCheck(this, Encoder);

    this.message_to_encode = message_to_encode;
  }

  _createClass(Encoder, [{
    key: 'setConfig',
    value: function setConfig(config) {
      this.config = config;
    }
  }, {
    key: 'getMessage',
    value: function getMessage() {
      return this.getObject().log();
    }
  }, {
    key: 'getObject',
    value: function getObject() {
      for (var key in this.config.mappings) {
        this._createSegment(key, this.config.mappings[key]);
      }
      return this.hl7_message;
    }
  }, {
    key: '_createSegment',
    value: function _createSegment(segmentName, segmentConfig) {
      var args = this._createContent(segmentName, segmentConfig);
      if (!this.hl7_message) {
        args.shift();
        this.hl7_message = new (Function.prototype.bind.apply(_simpleHl2.default.Message, [null].concat(_toConsumableArray(args))))();
        this.hl7_message.header.delimiters = this.config.delimiters;
      } else {
        var _hl7_message;

        (_hl7_message = this.hl7_message).addSegment.apply(_hl7_message, _toConsumableArray(args));
      }
    }
  }, {
    key: '_createContent',
    value: function _createContent(segmentName, segmentConfig) {
      var _this = this;

      var segment_arguments = [];
      segment_arguments.push(segmentName.toUpperCase());

      var _loop = function _loop(component_index) {
        var numberOfSeparatorInsideComponent = segmentConfig.configuration.components.seperators.filter(function (component) {
          return component.position === component_index;
        })[0];
        var fields = segmentConfig.values.filter(function (f) {
          return f.component && f.component[0] === component_index || f.children && f.children.filter(function (child) {
            return child.component[0] === component_index;
          }).length > 0;
        });
        var fields_content = [];
        var field_repetitive_content = [];
        if (fields.length > 0) {
          for (var i = 0; i < fields.length; i++) {
            if (!fields[i].children) {
              fields_content[fields[i].component[1] - 1] = _this._getFieldContent(_this.message_to_encode, fields[i]);
            } else {
              if (_this._deepFind(_this.message_to_encode, fields[i].field) && fields[i].type != 'array') {
                for (var rep = 0; rep < fields[i].children.length; rep++) {
                  fields_content[fields[i].children[rep].component[1] - 1] = _this._getFieldContent(_this._deepFind(_this.message_to_encode, fields[i].field), fields[i].children[rep]);
                }
              } else if (_this._deepFind(_this.message_to_encode, fields[i].field)) {
                for (var index_child = 0; index_child < _this._deepFind(_this.message_to_encode, fields[i].field).length; index_child++) {
                  var field_content_occurence = [];
                  for (var _rep = 0; _rep < fields[i].children.length; _rep++) {
                    field_content_occurence[fields[i].children[_rep].component[1] - 1] = _this._getFieldContent(_this._deepFind(_this.message_to_encode, fields[i].field)[index_child], fields[i].children[_rep]);
                  }
                  field_repetitive_content.push(field_content_occurence.join(_this.config.delimiters.componentSeperator));
                }
              }
            }
          }
          segment_arguments.push(field_repetitive_content.length === 0 ? fields_content.join(_this.config.delimiters.componentSeperator) : field_repetitive_content.join("~"));
        } else {
          segment_arguments.push(_this.config.delimiters.componentSeperator.repeat(numberOfSeparatorInsideComponent ? numberOfSeparatorInsideComponent.numberOfSeparator : 0));
        }
      };

      for (var component_index = 0; component_index < segmentConfig.configuration.components.count; component_index++) {
        _loop(component_index);
      }
      return segment_arguments;
    }
  }, {
    key: '_getFieldContent',
    value: function _getFieldContent(object, fieldConfig) {
      var field_content = void 0;

      if (this._deepFind(object, fieldConfig.field)) {
        field_content = this._deepFind(object, fieldConfig.field);
      } else if (fieldConfig.default) {
        field_content = fieldConfig.default;
      }

      return field_content;
    }
  }, {
    key: '_deepFind',
    value: function _deepFind(obj, path) {
      var paths = path.split('.');
      var current = obj;

      for (var i = 0; i < paths.length; ++i) {
        if (!current[paths[i]]) {
          return null;
        } else {
          current = current[paths[i]];
        }
      }
      return current;
    }
  }]);

  return Encoder;
}();

exports.default = Encoder;
//# sourceMappingURL=index.js.map
