'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.configure = configure;
exports.getADT04 = getADT04;
exports.getADT08 = getADT08;
exports.getADT40 = getADT40;
exports.getSIU12 = getSIU12;
exports.getSIU13 = getSIU13;
exports.getSIU14 = getSIU14;
exports.getSIU15 = getSIU15;
exports.getSIU17 = getSIU17;
exports.getSIU26 = getSIU26;

var _defaultHl = require('../class/default-hl7');

var _defaultHl2 = _interopRequireDefault(_defaultHl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var encoder = new _defaultHl2.default();

function configure(config) {
  if (config.version === 'hl7-2.4') return encoder = new _defaultHl2.default();
  throw new Error('Unknown format: ' + config.version);
}

function getADT04(message, config) {
  return encoder.getAdtEncoder(message).getA04(config);
}

function getADT08(message, config) {
  return encoder.getAdtEncoder(message).getA08(config);
}

function getADT40(message, config) {
  return encoder.getAdtEncoder(message).getA40(config);
}

function getSIU12(message, config) {
  return encoder.getSiuEncoder(message).getS12(config);
}

function getSIU13(message, config) {
  return encoder.getSiuEncoder(message).getS13(config);
}

function getSIU14(message, config) {
  return encoder.getSiuEncoder(message).getS14(config);
}

function getSIU15(message, config) {
  return encoder.getSiuEncoder(message).getS15(config);
}

function getSIU17(message, config) {
  return encoder.getSiuEncoder(message).getS17(config);
}

function getSIU26(message, config) {
  return encoder.getSiuEncoder(message).getS26(config);
}
//# sourceMappingURL=parser.js.map
